/*+------------------------------------------------------------------+
//| 5:58 PM 5/31/2020                          indicator_buffers.mqh |
//|                             Copyright  2020, WHRoeder@yahoo.com |
//|                                        mailto:WHRoeder@yahoo.com |
//+------------------------------------------------------------------+
//| Buffer support.                                                  |
//| A) Indicator_utilities.mqh defines Wingding and DrawType used in |
//|    BufferDefinition. Include that at beginning of the indicator. |
//| B) Add inputs and buffer definitions (as outlined below.)        |
//| C) Include THIS FILE AFTER all buffer #define's (or at end of    |
//|    the main file) to define OnInitBuffers().                     |
//| D) Call OnInitBuffers() in OnInit()                              |
//|    int i=OnInitBuffers(); if(i != INIT_SUCCEEDED) return i; ...  |
//+------------------------------------------------------------------+
//v- Example inputs and buffer definitions --------------------------v
//+------------------------------------------------------------------+
//{ Generic code                                                     |
//+------------------------------------------------------------------+
// :
//+------------------------------------------------------------------+
//} Generic code                                                     |
//{ Specific code                                                    |
//+------------------------------------------------------------------+
//---- input parameters
input ... gkInput1
#define  CHECK_PARAM1   gkInput1 > 0

//---- indicator buffers
#property   indicator_chart_window
#property   indicator_buffers N
#define     INDICATOR_DIGITS  ...                        // Defaults to _Digits.
#define     SHORTNAME         StringFormat(...)
//#property   indicator_type1      DRAW_LINE                  // Req build 1090
//#property   indicator_style1     STYLE_SOLID
//#property   indicator_width1     1
//#property   indicator_label1     "const"
//{ For data window, not shown on chart.
#property   indicator_color1  clrNONE
PRICE       bBuffer1[];
#define     INDICATOR_BUFFER1 lab(...).buf(bBuffer1)
//} For data window, not shown on chart.
//{ Shown on chart
//{ Shown on chart, not in data window.
#define     INDICATOR_BUFFER1 noData().buf(bBuffer1)
//} Shown on chart, not in data window.
//} Shown on chart
//{ extra buffers, not shown anywhere.
// #define  BUFFERS_COUNT_TOTAL  TBD                                 // Extra
//} extra buffers, not shown anywhere.
//+------------------------------------------------------------------+
//} Specific code                                                    |
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
#include <indicator_buffers.mqh>    // OnInitBuffers()
int OnInit(){
   int i=OnInitBuffers();  if(i != INIT_SUCCEEDED) return i;
   :
//^- Example inputs and buffer definitions --------------------------^*/
//+- Start of included code -----------------------------------------+
#include    <Indicator_utilities.mqh>  // BufferDefinition
//+------------------------------------------------------------------+
//| Custom indicator buffer initialization function                  |
//+------------------------------------------------------------------+
int      OnInitBuffers(){
   if(IS_DEBUG_MODE) Print("buffers");
   #ifndef INDICATOR_DIGITS
      #define  INDICATOR_DIGITS  _Digits                    // Default is 4
   #endif
   IndicatorDigits(INDICATOR_DIGITS);
   #ifdef   SHORTNAME
      IndicatorSetString(INDICATOR_SHORTNAME, SHORTNAME);
   #endif
   #ifdef   BUFFERS_COUNT_TOTAL
      IndicatorBuffers(BUFFERS_COUNT_TOTAL);
   #endif
   // Stringize only valid in a macro (build 1090.)
   #define  CHECK_PARAM(x) if(!(x)){   alert_id(#x);                           \
                                    return INIT_PARAMETERS_INCORRECT;   }
   #ifdef   CHECK_PARAM1
      CHECK_PARAM(CHECK_PARAM1);
   #endif
   #ifdef   CHECK_PARAM2
      CHECK_PARAM(CHECK_PARAM2);
   #endif
   #ifdef   CHECK_PARAM3
      CHECK_PARAM(CHECK_PARAM3);
   #endif
   #ifdef   CHECK_PARAM4
      CHECK_PARAM(CHECK_PARAM4);
   #endif
   #ifdef   CHECK_PARAM5
      CHECK_PARAM(CHECK_PARAM5);
   #endif
   #ifdef   CHECK_PARAM6
      CHECK_PARAM(CHECK_PARAM6);
   #endif
   #ifdef   CHECK_PARAM7
      CHECK_PARAM(CHECK_PARAM7);
   #endif
   #ifdef   CHECK_PARAM8
      CHECK_PARAM(CHECK_PARAM8);
   #endif
   #ifdef   CHECK_PARAM9
      CHECK_PARAM(CHECK_PARAM9);
   #endif
   #ifdef   CHECK_PARAM10
      CHECK_PARAM(CHECK_PARAM10);
   #endif
   #ifdef   CHECK_PARAM11
      CHECK_PARAM(CHECK_PARAM11);
   #endif
   #ifdef   CHECK_PARAM12
      CHECK_PARAM(CHECK_PARAM12);
   #endif
   #ifdef   INDICATOR_BUFFER1
      BufferDefinition B1(1);  if(!B1.INDICATOR_BUFFER1){
         alert_id(StringFormat("B1:%i", _LastError) );      return INIT_FAILED;}
   #endif
   #ifdef   INDICATOR_BUFFER2
      BufferDefinition B2(2);  if(!B2.INDICATOR_BUFFER2){
         alert_id(StringFormat("B2:%i", _LastError) );      return INIT_FAILED;}
   #endif
   #ifdef   INDICATOR_BUFFER3
      BufferDefinition B3(3);  if(!B3.INDICATOR_BUFFER3){
         alert_id(StringFormat("B3:%i", _LastError) );      return INIT_FAILED;}
   #endif
   #ifdef   INDICATOR_BUFFER4
      BufferDefinition B4(4);  if(!B4.INDICATOR_BUFFER4){
         alert_id(StringFormat("B4:%i", _LastError) );      return INIT_FAILED;}
   #endif
   #ifdef   INDICATOR_BUFFER5
      BufferDefinition B5(5);  if(!B5.INDICATOR_BUFFER5){
         alert_id(StringFormat("B5:%i", _LastError) );      return INIT_FAILED;}
   #endif
   #ifdef   INDICATOR_BUFFER6
      BufferDefinition B6(6);  if(!B6.INDICATOR_BUFFER6){
         alert_id(StringFormat("B6:%i", _LastError) );      return INIT_FAILED;}
   #endif
   #ifdef   INDICATOR_BUFFER7
      BufferDefinition B7(7);  if(!B7.INDICATOR_BUFFER7){
         alert_id(StringFormat("B7:%i", _LastError) );      return INIT_FAILED;}
   #endif
   #ifdef   INDICATOR_BUFFER8
      BufferDefinition B8(8);  if(!B8.INDICATOR_BUFFER8){
         alert_id(StringFormat("B8:%i", _LastError) );      return INIT_FAILED;}
   #endif
   #ifdef   INDICATOR_BUFFER9
      BufferDefinition B9(9);  if(!B9.INDICATOR_BUFFER9){
         alert_id(StringFormat("B9:%i", _LastError) );      return INIT_FAILED;}
   #endif
   #ifdef   INDICATOR_BUFFER10
      BufferDefinition B10(10);   if(!B10.INDICATOR_BUFFER10){
         alert_id(StringFormat("B10:%i", _LastError) );     return INIT_FAILED;}
   #endif
   #ifdef   INDICATOR_BUFFER11
      BufferDefinition B11(11);   if(!B11.INDICATOR_BUFFER11){
         alert_id(StringFormat("B11:%i", _LastError) );     return INIT_FAILED;}
   #endif
   #ifdef   INDICATOR_BUFFER12
      BufferDefinition B12(12);   if(!B12.INDICATOR_BUFFER12){
         alert_id(StringFormat("B12:%i", _LastError) );     return INIT_FAILED;}
   #endif
   #ifdef   INDICATOR_BUFFER13
      BufferDefinition B13(13);   if(!B13.INDICATOR_BUFFER13){
         alert_id(StringFormat("B13:%i", _LastError) );     return INIT_FAILED;}
   #endif
   #ifdef   INDICATOR_BUFFER14
      BufferDefinition B14(14);   if(!B14.INDICATOR_BUFFER14){
         alert_id(StringFormat("B14:%i", _LastError) );     return INIT_FAILED;}
   #endif
   #ifdef   INDICATOR_BUFFER15
      BufferDefinition B15(15);   if(!B15.INDICATOR_BUFFER15){
         alert_id(StringFormat("B15:%i", _LastError) );     return INIT_FAILED;}
   #endif
   #ifdef   INDICATOR_LEVEL1
      SetLevelValue(0, INDICATOR_LEVEL1);
      #ifdef   INDICATOR_LEVEL2
         SetLevelValue(1, INDICATOR_LEVEL2);
         #ifdef   INDICATOR_LEVEL3
            SetLevelValue(2, INDICATOR_LEVEL3);
            #ifdef   INDICATOR_LEVEL4
               SetLevelValue(3, INDICATOR_LEVEL4);
               #ifdef   INDICATOR_LEVEL5
                  SetLevelValue(4, INDICATOR_LEVEL5);
                  #ifdef   INDICATOR_LEVEL6
                     SetLevelValue(5, INDICATOR_LEVEL6);
                     #ifdef   INDICATOR_LEVEL7
                        SetLevelValue(6, INDICATOR_LEVEL7);
                        #ifdef   INDICATOR_LEVEL8
                           SetLevelValue(7, INDICATOR_LEVEL8);
                        #endif
                     #endif
                  #endif
               #endif
            #endif
         #endif
      #endif
   #endif
   if(IS_DEBUG_MODE) Print("init buffers ok");
//---
   return INIT_SUCCEEDED;
}  // OnInitBuffers
//+- indicator_buffers.mqh ------------------------------------------+
